%{
#undef YY_INPUT
#define YY_INPUT(b,r,ms) (r=str_yyinput(b,ms))

#include <stdio.h>
#include <stdlib.h>
#include <memory.h>

#include "errdef.h"

extern FILE * source;
extern FILE * output;

%}

Digit                [0-9]
Letter               [A-Za-z]
Filename             (({Letter}|{Digit}|"_"|".")+)

%x FNAME
%x FLAG

%%

%{
/* This is the init part of the yylex()    */
/* White space and EOL is important to lex */
%}

[ ]+               ;

-h                 |
-help              { 
   printf("The following are help info ......\n\n");
   exit(0);
}

-o                 {
                     BEGIN FNAME;
                   }

{Filename}         {
                     if ((source=fopen(yytext, "r"))==NULL)
                       errpro(file_source_open_failed);
                     return (1); 
                   }

.                  { 
                     printf("Usage: rule [-o output_filename] filename\n"
                            "   Or: rule [-help | -h] \n");
                     exit(0);
                   }

<FNAME>[ ]+        ;

<FNAME>{Filename}  {
                     if ((output=fopen(yytext, "w"))==NULL) {
                       errpro(file_output_open_failed); 
                     }      
                     BEGIN INITIAL;     
                   }

<FNAME>.           { 
                     errpro(file_name_missing);
                   }


%%
/*  Function and Varibles used as FLEX input;  */  

# include <memory.h>

char * str_buf_head;
char * str_buf_end;

int str_yyinput(char * buf, int max_size)
{
  int n;
  n=((max_size)<(str_buf_end-str_buf_head)?(max_size):(str_buf_end-str_buf_head));
  if (n>0) {
    memcpy(buf, str_buf_head, n);
    str_buf_head += n;
  }
  return n;
}







